<template>
<div class="uk-flex-around uk-width-xxlarge">

<div class="uk-section">
  <div class="uk-container">
    <div class="uk-card uk-card-default uk-border-rounded uk-margin-large-top">
        <div class="uk-card-header">
            <div class="uk-grid-small uk-flex-middle" uk-grid>
                <div class="uk-width-auto">
                    <!-- img class="uk-border-circle" width="40" height="40" src="https://getuikit.com/docs/images/avatar.jpg" -->
                </div>
                <div class="uk-width-expand">
                    <h3 class="uk-card-title uk-margin-remove-bottom">Chat id: {{ chat_ID }} </h3>
                </div>
            </div>
        </div>



      <div class="uk-card-body uk-padding-small uk-height-large uk-overflow-auto" id="chatbody">
		
		<div v-for="msg in messages" v-bind:key="msg.messages">
		
			<div v-if="msg.uid == loadedProfile.id">
				<div class="me uk-grid-small uk-flex-bottom uk-flex-right uk-text-right uk-margin-small-bottom" uk-grid>
				  <div class="uk-width-auto">
					<div class="uk-card uk-card-body uk-card-small uk-card-primary uk-border-rounded">
					  <p class="uk-margin-remove">{{ msg.message }}</p>
					</div>
				  </div>
				  <div class="uk-width-auto">
					<img class="uk-border-circle" width="32" height="32" :src="msg.profile_picture">
				  </div>
				</div>
			</div>
			
			<div v-else>
				<div class="guest uk-grid-small uk-flex-bottom uk-flex-left uk-margin-small-bottom" uk-grid>
				  <div class="uk-width-auto">
					<img class="uk-border-circle" width="32" height="32" :src="msg.profile_picture">
				  </div>
				  <div class="uk-width-auto">
					<div class="uk-card uk-card-body uk-card-small uk-card-default uk-border-rounded">
					  <p class="uk-margin-remove">{{ msg.message }}</p>
					</div>
				  </div>
				</div>		
			</div>
			
		</div>
		
      </div>

      <div class="uk-card-footer uk-padding-remove">
        <div class="uk-grid-small uk-flex-middle" uk-grid>
          <div class="uk-width-auto">
              <!-- --> 
          </div>


          <div class="uk-width-expand">
            <!-- <div class="uk-padding-small uk-padding-remove-horizontal">
              <textarea class="uk-textarea uk-padding-remove uk-border-remove" rows="1" placeholder="Escreva a mensagem..."></textarea>
            </div> -->
            <div class="uk-margin uk-padding-small uk-padding-remove-horizontal">
            <textarea v-model="message" class="uk-textarea" placeholder="send a message..."></textarea>
            </div>
          </div>
          <div class="uk-width-auto">
            <ul class="uk-iconnav uk-margin-small-right">
              <li>
                <button v-on:click="sendChat" class="uk-button uk-button-primary">Send</button>
              </li>
            </ul>
          </div>


        </div>
      </div>

    </div>

  </div>
</div>


</div>
</template>

<script>
import firebase from 'firebase'

export default {
  layout: 'app',
  data () {
      return {
		  message: '',
		  messages: [],
      }
  },
  beforeCreate () {
    console.log('Nothing gets called before me!')

  },
  mounted () {
        var chatid = this.chat_ID
			firebase.database().ref().child('chatroom/' + chatid + '/log').on('child_added', (data) => {
			// push the snapshot value into a data attribute
			this.messages.push(data.val())
				.then(() => {
				this.scrollbottom()
				})
			
			})
	  
},
  methods: {
      sendChat: function () {
		  console.log(this.message)
          this.$store.dispatch('sendChat', {
              uid: this.loadedProfile.id, 
			  name: this.loadedProfile.name,
			  profile_picture: this.loadedProfile.profile_picture,
			  message: this.message,
			  chat_ID: this.chat_ID
          }) 
		  //clear the message
		  this.message = ''
      },
	  scrollbottom: function () {
		  var element = document.getElementById("chatbody")
				element.scrollTop = element.scrollHeight
	  }

  },
  computed: {
	  chat_ID () {
        return this.$store.getters.chat_ID
  	  },
	  loadedProfile () {
          return this.$store.getters.loadedProfile
      }, 
    chatDetails () {
      return this.$store.getters.chatDetails
    }
  },
  updated () {
	  var element = document.getElementById("chatbody")
				element.scrollTop = element.scrollHeight
  }
}
</script>